<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{'user.title' | translate}}
          <span class="float-right">
            <button (click)="addUser()" [disabled]="isCreate || isEdit"
                    class="btn btn-block btn-primary">{{'common.add' | translate}}</button>
          </span>
        </div>
        <div class="card-body" *ngIf="users">
          <!---search and filter---->
          <div class="row justify-content-between mb-2">
            <div class="col-6">
              <span class="float-left pr-3 show-entity-per-page-label">{{'common.show' | translate}}</span>
              <select (change)="onSearch()" [(ngModel)]="paging.limit" class="form-control float-left"
                      style="max-width: 70px" [disabled]="isCreate || isEdit">
                <option *ngFor="let i of PAGING_PER_PAGE" value="{{i.value}}">{{i.label}}</option>
              </select>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input type="text" [(ngModel)]="txtSearch" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="onSearch()" class="btn btn-dark" type="button" [disabled]="isCreate || isEdit">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <form [formGroup]="userFormGroup">
            <table class="table table-bordered table-sort-icon">
              <thead>
              <tr appSort [disabled]="isCreate || isEdit" [(orderBy)]="order.orderBy" [(orderType)]="order.orderType" (orderChange)="changeOder($event)">
                <th appSortBy="user_name" class="text-center">
                  {{'profile.user_name'|translate}}
                  <fa-icon></fa-icon></th>
                <th class="text-center">{{'profile.password' |translate}}</th>
                <th appSortBy="phone_number" class="text-center">{{'profile.phone_number'|translate}}
                  <fa-icon></fa-icon></th>
                <th appSortBy="email" class="text-center">{{'profile.email'|translate}}
                  <fa-icon></fa-icon></th>
                <th appSortBy="can_edit" class="text-center">{{'profile.can_edit'|translate}}
                  <fa-icon></fa-icon></th>
                <th class="text-center">{{'common.action'|translate}}</th>
              </tr>
              </thead>
              <tbody formArrayName="data" *ngFor="let user of getFormData.controls; let i=index">
              <tr [formGroupName]="i">
                <!---------user_name------------->
                <td class="text-left">
                 <span *ngIf="!user.get('is_update').value">
                    {{user.get('user_name').value}}
                  </span>
                  <div *ngIf="user.get('is_update').value">
                    <input type="text" class="form-control" formControlName="user_name"
                           placeholder="{{'profile.user_name' |translate}}" pattern="^[_.@A-Za-z0-9-]*$">
                    <div
                      *ngIf="user.get('user_name').invalid && user.get('user_name').dirty || user.get('user_name').touched">
                      <span class="form-text text-danger"
                            *ngIf="user.get('user_name').errors?.required && user.get('user_name').touched ">
                        {{'error.validate.input_required' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="user.get('user_name').errors?.pattern">
                        {{'error.validate.pattern' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="user.get('user_name').errors?.minlength">
                        {{'error.validate.minlength' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="user.get('user_name').errors?.maxlenth">
                        {{'error.validate.maxlength' | translate}}
                      </span>
                    </div>
                  </div>
                </td>
                <!---------password------------->
                <td class="text-center">
                  <div class="input-group" *ngIf="!user.get('is_update').value">
                    <input [type]="user.get('is_show_password').value? 'text' : 'password'"
                           class="form-control" readonly="readonly"
                           [value]="user.get('password').value">
                    <div class="input-group-append">
                    <span
                      (click)="user.get('is_show_password').setValue(!user.get('is_show_password').value)"
                      class="input-group-text"
                      style="cursor: pointer;">
                      <i [class]="user.get('is_show_password').value? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i></span>
                    </div>
                  </div>
                  <div *ngIf="user.get('is_update').value">
                    <div class="input-group">
                      <input formControlName="password"
                             [type]="user.get('is_show_password').value? 'text' : 'password'"
                             class="form-control">
                      <div class="input-group-append">
                    <span (click)="user.get('is_show_password').setValue(!user.get('is_show_password').value)"
                          class="input-group-text"
                          style="cursor: pointer;">
                      <i [class]="user.get('is_show_password').value? 'fa fa-fw fa-eye-slash' : 'fa fa-fw fa-eye'"></i></span>
                      </div>
                    </div>
                    <div>
                      <span class="text-danger d-block"
                            *ngIf="user.get('password').errors && user.get('password').touched && user.get('password').errors.maxlength">{{'error.validate.password.maxlength' | translate}}</span>
                      <span class="text-danger d-block"
                            *ngIf="user.get('password').errors && user.get('password').touched && user.get('password').errors.required">{{'error.validate.password.required' | translate}}</span>
                      <span class="text-danger d-block"
                            *ngIf="user.get('password').errors && user.get('password').touched && user.get('password').errors.pattern">{{'error.validate.password.pattern' | translate}}</span>
                      <span class="text-danger d-block"
                            *ngIf="user.get('password').errors && user.get('password').touched && user.get('password').errors.minlength">{{'error.validate.password.minlength' | translate}}</span>
                    </div>
                  </div>
                </td>
                <!---------phone_number------------->
                <td class="text-right">
                 <span *ngIf="!user.get('is_update').value">
                    {{user.get('phone_number').value}}
                  </span>
                  <div *ngIf="user.get('is_update').value">
                    <input type="text" class="form-control" formControlName="phone_number"
                           placeholder="{{'profile.phone_number' |translate}}"
                           pattern="^\(?([0-9]{3})\)?[-. ]?([0-9]{3})[-. ]?([0-9]{4})$">
                    <div class="text-danger"
                         *ngIf="user.get('phone_number').invalid && user.get('phone_number').dirty || user.get('phone_number').touched">
                      <span class="form-text text-danger"
                            *ngIf="user.get('phone_number').errors?.pattern && user.get('phone_number').touched ">
                        {{'error.validate.pattern1' | translate}}
                      </span>
                    </div>
                  </div>
                </td>
                <td class="text-left">
                 <span *ngIf="!user.get('is_update').value">
                    {{user.get('email').value}}
                  </span>
                  <div *ngIf="user.get('is_update').value">
                    <input type="email" class="form-control" formControlName="email"
                           placeholder="{{'profile.email' |translate}}"
                           pattern="[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,3}$">
                    <span class="text-danger"
                          *ngIf="user.get('email').touched && user.get('email').invalid">{{'error.validate.input_valid' | translate}}</span>
                  </div>
                </td>
                <!---------can_edit ------------->
                <td class="text-center">
                  <span *ngIf="!user.get('is_update').value">
                      <span class="badge badge-primary"
                            *ngIf="user.get('can_edit').value === CANEDIT_STATUS.YES">Yes</span>
                      <span class="badge badge-warning"
                            *ngIf="user.get('can_edit').value === CANEDIT_STATUS.NO">No</span>
                  </span>
                  <div *ngIf="user.get('is_update').value">
                    <select class="form-control" formControlName="can_edit" name="can_edit">
                      <option value="1">Yes</option>
                      <option value="0">No</option>
                    </select>
                    <span class="text-danger"
                          *ngIf="user.get('can_edit').touched && user.get('can_edit').invalid">{{'error.validate.input_required' | translate}}</span>
                  </div>
                </td>
                <td class="text-center">
                  <div class="btn-group">
                    <button *ngIf="!user.get('is_update').value" (click)="onEdit(i)"
                            type="submit" [disabled]="isCreate || isEdit"
                            class="btn btn-success btn-sm">
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                    </button>
                    <button *ngIf="user.get('is_update').value" (click)="save(i)" type="submit"
                            [disabled]="user.invalid || (!user.get('phone_number').value && !user.get('email').value)"
                            class="btn btn-primary btn-sm">
                      <i class="fa fa-save"></i>
                      <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                    </button>
                    <button *ngIf="!user.get('is_update').value" type="submit" (click)="remove(deleteModal, i)"
                            class="btn btn-danger btn-sm" [disabled]="isCreate || isEdit">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                    </button>
                    <button *ngIf="user.get('is_update').value" type="submit" (click)="onCancelEdit(i)"
                            class="btn btn-danger btn-sm">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                    </button>
                  </div>
                </td>
              </tr>
              </tbody>
            </table>
          </form>
          <div class="row justify-content-between" *ngIf="users.length > 0">
            <span class="col-6">{{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + getFormData.controls.length),
              total: paging.total
            } }}</span>

            <div class="col-6">
              <ngb-pagination class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)">
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="!users || users.length === 0" class="text-center">
            <span>{{'common.no_record' | translate}}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'user.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'user.delete_popup.message' | translate: {name: selectedUser.user_name} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger"
            (click)="modal.close('delete')">{{'common.delete' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>

<ng-template #saveModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-save-title">{{'user.save_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body" *ngIf="isEdit">
    {{'object.account.save_popup.message' | translate: {name: selectedUser.name}  }}
  </div>

  <div class="modal-body" *ngIf="!isEdit">
    {{'object.account.save_popup.alert' | translate }}
  </div>

  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('save')">{{'common.save' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>
